#ifndef stencil_func_helpers_h
#define stencil_func_helpers_h

#include "stencil_func.h"

template<int dim, typename T, typename I>
std::array<std::string,dim> mix_stencil_names(const std::array<std::string,dim>& s1, const std::array<std::string,dim>& s2);

template<int dim, typename T, typename I, typename ST>
void add_uniq_stencil_points(std::vector<T>&, std::vector<ST>&, typename std::vector<T>::const_iterator, typename std::vector<T>::const_iterator, typename std::vector<ST>::const_iterator, typename std::vector<ST>::const_iterator, const T& );

template<int dim, typename T, typename I, typename ST = std::array<I,dim>>
void add_uniq_stencil_points(std::vector<T>& target_coefficients, std::vector<ST>& target_positions, const std::vector<T>& source_coefficients, const std::vector<ST>& source_positions, const T& factor=1.);

template<int dim, typename T, typename I>
std::array<I,dim> compare_strides(const std::array<I,dim>&, const std::array<I,dim>&);

template<int dim, typename T, typename I, typename ST = std::array<I,dim>>
bool same_stencil_points(T, const std::vector<T>&, std::vector<ST>&, T, const std::vector<T>&, const std::vector<ST>&);

template<typename T, typename I, class names, bool HD, bool is_function, bool is_deltas, bool is_coords, class ... f_args>
void optimize(stencil_func<T,I,names,HD,is_function,is_deltas,is_coords,f_args...>&);

#include "stencil_func_helpers.hpp"
#endif
